//
// Application.java
// Project EOInspector
//
// Created by SUZUKI Tetsuya <suzuki@spice-of-life.net>

import java.util.*;
import java.io.*;
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;
import groovy.lang.*;

public class Application extends WOApplication {
    protected ByteArrayOutputStream out;
	
    public static void main(String argv[]) {
        WOApplication.main(argv, Application.class);
    }

    public Application() {
        super();
        System.out.println("Welcome to " + this.name() + "!");
        
        EOClassDescription.setClassDelegate(DelegateLogger.defaultLogger());
        EOModelGroup.setClassDelegate(DelegateLogger.defaultLogger());
        EOModelGroup.defaultGroup().setDelegate(DelegateLogger.defaultLogger());
        EOModelGroup.defaultGroup().
            setClassDelegate(DelegateLogger.defaultLogger());
        NSNotificationCenter.defaultCenter().
            addOmniscientObserver(DelegateLogger.defaultLogger(),
                                  DelegateLogger.omniNotificationSelector);
								  
		out = new ByteArrayOutputStream();
		PrintStream ps = new PrintStream(out);
		NSLog.PrintStreamLogger nsps = new NSLog.PrintStreamLogger(ps);
		NSLog.setDebug(nsps);
		//NSLog.setOut(nsps);
		//NSLog.setErr(nsps);
		NSLog.allowDebugLoggingForGroups(NSLog.DebugGroupDatabaseAccess + NSLog.DebugGroupSQLGeneration);
		NSLog.setAllowedDebugLevel(NSLog.DebugLevelInformational);
    }
    
	public NSArray sqlLogs() {
		NSMutableArray logs = new NSMutableArray();
		byte[] bytes = out.toByteArray();
		String[] lines = new String(bytes).split("\n");
		for (int i = 0; i < lines.length; i++) {
			logs.addObject(lines[i]);
		}
		return logs;
	}
	
	public void flushLogs() {
		out.reset();
	}
}
