//
//  EOGenericRecordInspector.java
//  EOInspector
//

import java.util.*;
import com.webobjects.foundation.*;
import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;

public class EOGenericRecordInspector extends Inspector {

	public String bindingBaseName() {
		return "eo";
	}
	
	public EOEnterpriseObject eo() {
		return (EOEnterpriseObject)object();
	}

	public EOEditingContext ec() {
		return eo().editingContext();
	}

	public EOObjectStoreCoordinator osc() {
		return (EOObjectStoreCoordinator)ec().rootObjectStore();
	}

	public EODatabaseContext databaseContext() {
		return (EODatabaseContext)osc().objectStoreForObject(eo());
	}

	public EODatabase database() {
		return databaseContext().database();
	}

    public NSArray allKeys() {
		NSMutableArray keys =  new NSMutableArray(new Object[] {
			"entityName", "globalID", "isFault", "isLocked", "editingContext",
			"snapshot", "snapshotInDatabaseContext", "snapshotInDatabase",
			"databaseContext", "database", "allPropertyKeys", "attributeKeys",
			"toOneRelationshipKeys", "toManyRelationshipKeys",
			"classDescription", "eoDescription", "description"});
		Enumeration e = eo().allPropertyKeys().objectEnumerator();
		while (e.hasMoreElements()) {
			keys.addObject(e.nextElement().toString());
		}
		return keys;
	}

    public NSArray allActions() {
		return new NSArray(new Object[] {
			"lock", "delete", "invalidate", "refault", "refresh"});
	}

	public EOGlobalID globalID() {
		return ec().globalIDForObject(eo());
	}

	public NSDictionary snapshotInDatabase() {
		return database().snapshotForGlobalID(globalID());
	}

	public NSDictionary snapshotInDatabaseContext() {
		return databaseContext().snapshotForGlobalID(globalID());
	}

	public boolean isLocked() {
		return ec().isObjectLockedWithGlobalID(globalID(), ec());
	}

	public void lock() {
		ec().lockObject(eo());
	}

	public void refault() {
		ec().refaultObject(eo());
	}

	public void refresh() {
		ec().refreshObject(eo());
	}

	public void delete() {
		ec().deleteObject(eo());
	}

	public void invalidate() {
		ec().invalidateObjectsWithGlobalIDs(new NSArray(globalID()));
	}

}
