//
//  EOObjectStoreCoordinatorInspector.java
//  EOInspector
//

import java.util.*;
import com.webobjects.foundation.*;
import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;

public class EOObjectStoreCoordinatorInspector extends Inspector {

	public String bindingBaseName() {
		return "osc";
	}
	
	public void inspectorDidSetObject() {
		// dummy to set delegates
		EOEditingContext ec = new EOEditingContext(osc());
		EOFetchSpecification fs = new EOFetchSpecification("Movie", null, null);
		fs.setFetchLimit(1);
		ec.objectsWithFetchSpecification(fs);

		Enumeration e = osc().cooperatingObjectStores().objectEnumerator();
		while (e.hasMoreElements()) {
			EODatabaseContext dbCxt = (EODatabaseContext)e.nextElement();
			dbCxt.setDelegate(DelegateLogger.defaultLogger());
			EOAdaptorContext adCxt = dbCxt.adaptorContext();
			adCxt.setDelegate(DelegateLogger.defaultLogger());
			adCxt.adaptor().setDelegate(DelegateLogger.defaultLogger());

			Enumeration adChlE = adCxt.channels().objectEnumerator();
			while (adChlE.hasMoreElements()) {
				EOAdaptorChannel adChl = (EOAdaptorChannel)adChlE.nextElement();
				adChl.setDelegate(DelegateLogger.defaultLogger());
			}
		}
	}

	public EOObjectStoreCoordinator osc() {
		return (EOObjectStoreCoordinator)object();
	}

    public NSArray allKeys() {
		return new NSMutableArray(new Object[] {
			"cooperatingObjectStores", "description"});
	}

    public NSArray allActions() {
		return new NSArray(new Object[] {
			"createEditingContext", "invalidateAllObjects"});
	}

	public void createEditingContext() {
		EOEditingContext ec = new EOEditingContext(osc());
		System.out.println(DelegateLogger.defaultLogger().toString());
		ec.setDelegate(DelegateLogger.defaultLogger());
		registerObject(ec);
	}

}
