//
//  Log.java
//  EOInspector
//

import java.util.*;
import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;

public class Log {
	static String Key = "Key";
	static String EntityKey = "Entity";
	static String AttributeKey = "Attribute";
	static String RelationshipKey = "Relationship";
	static String AdaptorKey = "Adaptor";
	static String AdaptorChannelKey = "AdaptorChannel";
	static String AdaptorContextKey = "AdaptorContext";
	static String AdaptorOperationKey = "AdaptorOperation";
	static String DatabaseChannelKey = "DatabaseChannel";
	static String DatabaseContextKey = "DatabaseContext";
	static String DatabaseOperationKey = "DatabaseOperation";
	static String GlobalIDKey = "GlobalID";
	static String EditingContextKey = "EditingContext";
	static String EnterpriseObjectKey = "EnterpriseObject";
	static String FetchSpecKey = "FetchSpec";
	static String DictionaryKey = "Dictionary";
	static String Dictionary2Key = "Dictionary2";
	static String ArrayKey = "Array";
	static String ExceptionKey = "Exception";
	static String SQLExpressionKey = "SQLExpression";
	static String StoredProcedureKey = "StoredProcedure";
	static String LockKey = "Lock";
	static String ValueKey = "Value";
	static String UsesPessimisticLockKey = "UsesPessimisticLock";

	String methodName, transactionName;
	long timestamp;
	NSDictionary userinfo;
	Object target;

	public Log(Object target, String methodName, long timestamp,
			   NSDictionary userinfo, String transactionName) {
		this.target = target;
		this.methodName = methodName;
		this.timestamp = timestamp;
		this.userinfo = userinfo;
    this.transactionName = transactionName;
	}

	public Object target() {
		return target;
	}

	public String targetClassName() {
		return Inspector.baseClassName(target);
	}

	public String objectID() {
		return Integer.toHexString(target.hashCode()).toString();
	}

	public String methodName() {
		return methodName;
	}

	public String transactionName() {
		return transactionName;
	}

	public long timestamp() {
		return timestamp;
	}

	public NSDictionary userinfo() {
		return userinfo;
	}

	public Object valueForKey(String key) {
		return NSKeyValueCoding.DefaultImplementation.valueForKey(this, key);
	}

	public void takeValueForKey(Object value, String key) {
		NSKeyValueCoding.DefaultImplementation.takeValueForKey(this, value, key);
	}

	public String toString() {
		return ("(" + new Date(timestamp).toString() + ") " +
				methodName + ": " + userinfo);
	}
}
