//
//  LoggerInspector.java
//  EOInspector
//

import java.util.*;
import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;

public class LoggerInspector extends Inspector {

	public Logger logger() {
		return (Logger)object();
	}

	public String bindingBaseName() {
		return "logger";
	}
	
    public NSArray allKeys() {
		return new NSArray(new Object[] {
			"methodName", "target", "logs", "parentLogger", "rootLogger",
			"description"});
	}

    public NSArray allActions() {
		return new NSArray(new Object[] {
			"update", "removeLogs", "removeAllLogs"});
	}

	public void removeLogs() {
		if (logger().parentLogger() != null)
			logger().parentLogger().removeLogs(logger().logs());
		logger().removeAllLogs();
	}

	public void removeAllLogs() {
		if (logger().parentLogger() != null)
			logger().parentLogger().removeAllLogs();
		logger().removeAllLogs();
	}

	public void update() {
		logger().update();
	}

}
