//
//  NSArrayInspector.java
//  EOInspector
//

import java.util.*;
import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;

public class NSArrayInspector extends Inspector {

	public String bindingBaseName() {
		return "array";
	}
	
	public NSArray array() {
		return (NSArray)object();
	}

    public NSArray allKeys() {
		NSMutableArray keys =
			new NSMutableArray(new Object[] {"containedObjects", "lastObject",
											 "description"});

		Enumeration e = array().operatorNames().objectEnumerator();
		while (e.hasMoreElements()) {
			keys.addObject("@" + e.nextElement().toString());
		}

		for (int i = 0; i < array().count(); i++) {
			keys.addObject(new Integer(i).toString());
		}
		return keys;
	}

    public NSArray allActions() {
		return new NSArray(new Object[]{});
	}

	public Object valueForKey(String key) {
		Enumeration enu = array().operatorNames().objectEnumerator();
		while (enu.hasMoreElements()) {
			if (key.equals("@" + enu.nextElement().toString()))
				return array().valueForKeyPath(key);
		}

		try {
			return array().objectAtIndex(Integer.parseInt(key));
		} catch (NumberFormatException e) {
			return NSKeyValueCoding.DefaultImplementation.valueForKey(this, key);
		}
	}

	public NSArray containedObjects() {
		return array();
	}

	public Object lastObject() {
		return array().lastObject();
	}

	public int count() {
		return array().count();
	}

	public NSArray operatorNames() {
		return array().operatorNames();
	}
}
